/*
 * 10 BUTTON NUMPAD 
 * 1 FOR TURN ON 1st SWITCH,
   2 FOR TURN ON 2ND SWITCH,  
   3 FOR TURN ON 3RD SWITCH
   4 FOR TURN OFF 1ST SWITCH
   5 FOR TURN OFF 2ND SWITCH   
   6 FOR TURN OFF 3RD SWITCH         
*/



#include "AdafruitIO_WiFi.h"
#include <Stepper.h>
#include <Servo.h>


// WIFI CREDENTIAL
#define WIFI_SSID "test-1"
#define WIFI_PASS "123456789"


// ADAFRUIT CREDENTIALS 
#define IO_USERNAME  "usertest"
#define IO_KEY       "aio_Enso88GZmB8RWVTNIJY28Q1UxgHw"


AdafruitIO_WiFi io(IO_USERNAME, IO_KEY, WIFI_SSID, WIFI_PASS);

AdafruitIO_Feed *digital = io.feed("Numpad_value");                  // feed name must be same and case sensitive

const int stepsPerRevolution = 100;                            // steps per revolution of the stepper motor
Stepper myStepper(stepsPerRevolution, 14,12,13,15);            // stepper motor pin connected to pin D5(14), D6(12), D7(13), D8(15) of nodemcu
Servo mg90;                                                    // creating the object for the servo motor

void setup() 
{
  myStepper.setSpeed(100);                                     // set the servo motor speed to 100
  mg90.attach(5);                                              // servo signal pin connected to D1(5)of nodemcu
  Serial.begin(115200);                                        // initialization of serial communication
  while(! Serial)
 {
//   connect to io.adafruit.com
  Serial.print("Connecting to Adafruit IO");
  io.connect();
 } 
  digital->onMessage(handleMessage);

  // wait for a connection
  while(io.status() < AIO_CONNECTED) 
  {
    Serial.print(".");
    delay(500);
  }
  Serial.println(io.statusText());
  digital->get();
}

void loop() 
{
 io.run();
}

void handleMessage(AdafruitIO_Data *data) 
{
  int num = data ->toInt();                   
  if(num == 1)                                //for turn on 1st button
    {
      Serial.println("button 1 is ON");
      myStepper.step(0);
      delay(500);
      mg.write(0);
      delay(100);
      mg.write(50);
      delay(100);
      myStepper.step(0);  
      delay(500);
    }
  if(num== 2)                                //for turn on 2nd button 
    {
      Serial.println("button 2 is ON");
      myStepper.step(150);
      delay(500);
      mg.write(0);
      delay(100);
      mg.write(50);
      delay(100);
      myStepper.step(0);  
      delay(100);
      myStepper.step(-150);
      delay(500);
    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
  if(num== 3)                                //for turn on 3rd button
    { 
      Serial.println("button 3 is ON");
      myStepper.step(250);
      delay(500);
      mg.write(0);
      delay(100);
      mg.write(50);
      delay(100);
      myStepper.step(0);  
      delay(100);
      myStepper.step(-250);
      delay(500);
    }
  if(num== 4)                            // for turn off 1st button
    {
      Serial.println("button 1 is OFF");
      myStepper.step(0);
      delay(500);
      mg.write(120);
      delay(100);
      mg.write(50);
      delay(100);
      myStepper.step(0);  
      delay(500);
    }    
  if(num == 5)                           // for turn off 2nd button
    {
      Serial.println("button 2 is OFF");
      myStepper.step(150);
      delay(500);
      mg.write(120);
      delay(100);
      mg.write(50);
      delay(100);      
      myStepper.step(0);  
      delay(100);  
      myStepper.step(-150);
      delay(500);
    }    
  if(num == 6)                          // for turn off 3rd button
    {
      Serial.println("button 3 is OFF");
      myStepper.step(250);
      delay(500);
      mg.write(120);
      delay(100);
      mg.write(50);
      delay(100);
      myStepper.step(0);  
      delay(100);  
      myStepper.step(-250);
      delay(500);
    }            
      myStepper.step(0);  
      mg.write(50);  
}
